#### POSIX Threads for Windows – REFERENCE - Pthreads-w32

Reference Index

Table of Contents

## Name

pthread_spin_lock, pthread_spin_trylock - lock a spin lock object (ADVANCED REALTIME THREADS)

## Synopsis

#include <pthread.h>

int pthread_spin_lock(pthread_spinlock_t *lock);
int pthread_spin_trylock(pthread_spinlock_t *lock);

## Description

The pthread_spin_lock function shall lock the spin lock referenced by lock. The calling thread shall acquire the lock if it is not held by another thread. Otherwise, the thread shall spin (that is, shall not return from the pthread_spin_lock call) until the lock becomes available. The results are undefined if the calling thread holds the lock at the time the call is made.

Pthreads-w32 supports single and multiple processor systems as well as process CPU affinity masking by checking the mask when the spin lock is initialized. If the process is using only a single processor at the time pthread_spin_init(3) is called then the spin lock is initialized as a PTHREAD_MUTEX_NORMAL mutex object. A thread that calls pthread_spin_lock will block rather than spin in this case. If the process CPU affinity mask is altered after the spin lock has been initialised, the spin lock is not modified, and may no longer be optimal for the number of CPUs available.

The pthread_spin_trylock function shall lock the spin lock referenced by lock if it is not held by any thread. Otherwise, the function shall fail.

The results are undefined if any of these functions is called with an uninitialized spin lock.

## Return Value

Upon successful completion, these functions shall return zero; otherwise, an error number shall be returned to indicate the error.

## Errors

These functions may fail if:

EINVAL
  The value specified by lock does not refer to an initialized spin lock object.

The pthread_spin_trylock function shall fail if:

EBUSY
  A thread currently holds the lock.

These functions shall not return an error code of [EINTR].

The following sections are informative.

## Examples

None.

## Application Usage

Applications using this function may be subject to priority inversion, as discussed in the Base Definitions volume of IEEE Std 1003.1-2001, Section 3.285, Priority Inversion.

## Rationale

None.

## Future Directions

None.

## See Also

pthread_spin_destroy(3) , pthread_spin_unlock(3) , the Base Definitions volume of IEEE Std 1003.1-2001, <pthread.h>

## Copyright

Portions of this text are reprinted and reproduced in electronic form from IEEE Std 1003.1, 2003 Edition, Standard for Information Technology -- Portable Operating System Interface (POSIX), The Open Group Base Specifications Issue 6, Copyright (C) 2001-2003 by the Institute of Electrical and Electronics Engineers, Inc and The Open Group. In the event of any discrepancy between this version and the original IEEE and The Open Group Standard, the original IEEE and The Open Group Standard is the referee document. The original Standard can be obtained online at http://www.opengroup.org/unix/online.html .

Modified by Ross Johnson for use with Pthreads-w32.

Table of Contents

- Name

- Synopsis

- Description

- Return Value

- Errors

- Examples

- Application Usage

- Rationale

- Future Directions

- See Also

- Copyright